Index: /palm/trunk/UTIL/Makefile_utilities
===================================================================
--- /palm/trunk/UTIL/Makefile_utilities	(revision 3865)
+++ /palm/trunk/UTIL/Makefile_utilities	(revision 3866)
@@ -23,4 +23,8 @@
 # -----------------
 # $Id$
+# Use PALM's kinds module in inifor
+# 
+# 
+# 3795 2019-03-15 09:40:05Z eckhard
 # Upated inifor build dependencies
 # 
@@ -141,4 +145,6 @@
 	inifor_defs.o \
 	inifor_util.o
+inifor_defs.o: \
+	mod_kinds.o
 inifor_grid.o: \
 	inifor_control.o \
Index: /palm/trunk/UTIL/inifor/src/inifor.f90
===================================================================
--- /palm/trunk/UTIL/inifor/src/inifor.f90	(revision 3865)
+++ /palm/trunk/UTIL/inifor/src/inifor.f90	(revision 3866)
@@ -26,4 +26,11 @@
 ! -----------------
 ! $Id$
+! Use PALM's working precision
+! Show error message if compiled without netCDF support
+! Renamed run_control -> log_runtime
+! Improved coding style added comments
+! 
+! 
+! 3785 2019-03-06 10:41:14Z eckhard
 ! Average geostrophic wind components on coarse COSMO levels instead of fine PALM levels
 ! Remove --debug netCDF output of internal pressure profiles
@@ -81,4 +88,5 @@
 !------------------------------------------------------------------------------!
  PROGRAM inifor
+
 #if defined ( __netcdf )
 
@@ -86,17 +94,43 @@
     USE inifor_defs
     USE inifor_grid,                                                           &
-        ONLY:  setup_parameters, setup_grids, setup_variable_tables,           &
-               setup_io_groups, fini_grids, fini_variables, fini_io_groups,    &
-               fini_file_lists, preprocess, origin_lon, origin_lat,            &
-               output_file, io_group_list, output_var_table,                   &
-               cosmo_grid, palm_grid, nx, ny, nz, p0, cfg, f3,                 &
-               averaging_width_ns, averaging_width_ew, phi_n, lambda_n,        &
-               lam_centre, phi_centre
+        ONLY:  averaging_width_ns,                                             &
+               averaging_width_ew,                                             &
+               cfg,                                                            &    
+               cosmo_grid,                                                     &
+               f3,                                                             &
+               fini_grids,                                                     &
+               fini_io_groups,                                                 &
+               fini_variables,                                                 &
+               fini_file_lists,                                                &
+               io_group_list,                                                  &
+               lam_centre,                                                     &
+               lambda_n,                                                       &
+               nx, ny, nz,                                                     &
+               origin_lat,                                                     &
+               origin_lon,                                                     &
+               output_file,                                                    &
+               output_var_table,                                               &
+               p0,                                                             &
+               phi_centre,                                                     &
+               phi_n,                                                          &
+               preprocess,                                                     &
+               palm_grid,                                                      &
+               setup_grids,                                                    &
+               setup_parameters,                                               &
+               setup_variable_tables,                                          &
+               setup_io_groups
     USE inifor_io
     USE inifor_transform,                                                      &
-        ONLY:  average_pressure_perturbation, average_profile, interpolate_1d, &
-               interpolate_1d_arr, interpolate_2d, interpolate_3d,             &
-               interp_average_profile, geostrophic_winds, extrapolate_density, &
-               extrapolate_pressure, get_surface_pressure
+        ONLY:  average_pressure_perturbation,                                  &
+               average_profile,                                                & 
+               extrapolate_density,                                            &
+               extrapolate_pressure,                                           & 
+               geostrophic_winds,                                              &
+               get_surface_pressure,                                           &
+               interp_average_profile,                                         &
+               interpolate_1d,                                                 &
+               interpolate_1d_arr,                                             & 
+               interpolate_2d,                                                 &
+               interpolate_3d
     USE inifor_types
     
@@ -107,21 +141,21 @@
     INTEGER ::  iter   !< loop index for time steps
 
-    REAL(dp), ALLOCATABLE, DIMENSION(:,:,:)     ::  output_arr !< array buffer for interpolated quantities
-    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  rho_centre !< density profile of the centre averaging domain
-    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  ug_cosmo   !< profile of the geostrophic wind in x direction on COSMO levels
-    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  vg_cosmo   !< profile of the geostrophic wind in y direction on COSMO levels
-    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  ug_palm    !< profile of the geostrophic wind in x direction interpolated onto PALM levels
-    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  vg_palm    !< profile of the geostrophic wind in y direction interpolated onto PALM levels
-    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  rho_north  !< density profile of the northern averaging domain
-    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  rho_south  !< density profile of the southern averaging domain
-    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  rho_east   !< density profile of the eastern averaging domain
-    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  rho_west   !< density profile of the western averaging domain
-    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  p_north    !< pressure profile of the northern averaging domain
-    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  p_south    !< pressure profile of the southern averaging domain
-    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  p_east     !< pressure profile of the eastern averaging domain
-    REAL(dp), ALLOCATABLE, DIMENSION(:), TARGET ::  p_west     !< pressure profile of the western averaging domain
-
-    REAL(dp), POINTER, DIMENSION(:) ::  internal_arr !< pointer to the currently processed internal array (density, pressure)
-    REAL(dp), POINTER, DIMENSION(:) ::  ug_vg_palm   !< pointer to the currently processed geostrophic wind component
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:)     ::  output_arr !< array buffer for interpolated quantities
+    REAL(wp), ALLOCATABLE, DIMENSION(:), TARGET ::  rho_centre !< density profile of the centre averaging domain
+    REAL(wp), ALLOCATABLE, DIMENSION(:), TARGET ::  ug_cosmo   !< profile of the geostrophic wind in x direction on COSMO levels
+    REAL(wp), ALLOCATABLE, DIMENSION(:), TARGET ::  vg_cosmo   !< profile of the geostrophic wind in y direction on COSMO levels
+    REAL(wp), ALLOCATABLE, DIMENSION(:), TARGET ::  ug_palm    !< profile of the geostrophic wind in x direction interpolated onto PALM levels
+    REAL(wp), ALLOCATABLE, DIMENSION(:), TARGET ::  vg_palm    !< profile of the geostrophic wind in y direction interpolated onto PALM levels
+    REAL(wp), ALLOCATABLE, DIMENSION(:), TARGET ::  rho_north  !< density profile of the northern averaging domain
+    REAL(wp), ALLOCATABLE, DIMENSION(:), TARGET ::  rho_south  !< density profile of the southern averaging domain
+    REAL(wp), ALLOCATABLE, DIMENSION(:), TARGET ::  rho_east   !< density profile of the eastern averaging domain
+    REAL(wp), ALLOCATABLE, DIMENSION(:), TARGET ::  rho_west   !< density profile of the western averaging domain
+    REAL(wp), ALLOCATABLE, DIMENSION(:), TARGET ::  p_north    !< pressure profile of the northern averaging domain
+    REAL(wp), ALLOCATABLE, DIMENSION(:), TARGET ::  p_south    !< pressure profile of the southern averaging domain
+    REAL(wp), ALLOCATABLE, DIMENSION(:), TARGET ::  p_east     !< pressure profile of the eastern averaging domain
+    REAL(wp), ALLOCATABLE, DIMENSION(:), TARGET ::  p_west     !< pressure profile of the western averaging domain
+
+    REAL(wp), POINTER, DIMENSION(:) ::  internal_arr !< pointer to the currently processed internal array (density, pressure)
+    REAL(wp), POINTER, DIMENSION(:) ::  ug_vg_palm   !< pointer to the currently processed geostrophic wind component
 
     TYPE(nc_var), POINTER        ::  output_var      !< pointer to the currently processed output variable
@@ -138,216 +172,235 @@
 !- Section 1: Initialization
 !------------------------------------------------------------------------------
- CALL run_control('init', 'void')
+    CALL log_runtime( 'init', 'void' )
 
 !
 !-- Initialize INIFOR's parameters from command-line interface and namelists
-    CALL setup_parameters()
+    CALL setup_parameters
 
 !
 !-- Initialize all grids, including interpolation neighbours and weights
-    CALL setup_grids()
- CALL run_control('time', 'init')
+    CALL setup_grids
+    CALL log_runtime( 'time', 'init' )
 
 !
 !-- Initialize the netCDF output file and define dimensions
-    CALL setup_netcdf_dimensions(output_file, palm_grid, cfg % start_date,    &
+    CALL setup_netcdf_dimensions(output_file, palm_grid, cfg%start_date,    &
                                  origin_lon, origin_lat)
- CALL run_control('time', 'write')
+    CALL log_runtime( 'time', 'write' )
 
 !
 !-- Set up the tables containing the input and output variables and set
 !-- the corresponding netCDF dimensions for each output variable
-    CALL setup_variable_tables(cfg % ic_mode)
- CALL run_control('time', 'write')
+    CALL setup_variable_tables( cfg%ic_mode )
+    CALL log_runtime( 'time', 'write' )
 
 !
 !-- Add the output variables to the netCDF output file
-    CALL setup_netcdf_variables(output_file % name, output_var_table)
-
-    CALL setup_io_groups()
- CALL run_control('time', 'init')
-
-!------------------------------------------------------------------------------
-!- Section 2: Main loop
-!------------------------------------------------------------------------------
-    DO igroup = 1, SIZE(io_group_list)
+    CALL setup_netcdf_variables( output_file%name, output_var_table )
+
+    CALL setup_io_groups
+    CALL log_runtime( 'time', 'init' )
+
+!------------------------------------------------------------------------------
+!-- Section 2: Main loop
+!------------------------------------------------------------------------------
+!
+!-- Input and output variables are organized into IO groups. For instance, the
+!-- 'thermodynamics' IO group bundles the input variaebls T, P, QV and the
+!-- output variables p, theta, rho, and qv.
+!-- An IO group bunldes variables that are physically dependent on each other.
+!-- In case of the 'thermodynamics' group, theta = f(P,T), rho = f(P,T,QV).
+    DO  igroup = 1, SIZE( io_group_list )
 
        group => io_group_list(igroup)
-       IF ( group % to_be_processed )  THEN
+       IF ( group%to_be_processed )  THEN
           
-          DO iter = 1, group % nt 
-
-!------------------------------------------------------------------------------
-!- Section 2.1: Read and preprocess input data
-!------------------------------------------------------------------------------
-             CALL read_input_variables(group, iter, input_buffer)
- CALL run_control('time', 'read')
-
-             CALL preprocess(group, input_buffer, cosmo_grid, iter)
- CALL run_control('time', 'comp')
+!--       Loop over all output time steps for the current group.
+          DO  iter = 1, group%nt 
+
+!------------------------------------------------------------------------------
+!-- Section 2.1: Read and preprocess input data
+!------------------------------------------------------------------------------
+             CALL read_input_variables( group, iter, input_buffer )
+             CALL log_runtime( 'time', 'read' )
+
+!--          Carry out all required physical conversion of the input variables
+!--          of the current IO group on the input (COSMO) grid. For instance,
+!--          horizontal velocities are rotated to the PALM coordinate system and
+!--          potential temperature is computed from the absolute temperature and
+!--          pressure.
+             CALL preprocess( group, input_buffer, cosmo_grid, iter )
+             CALL log_runtime( 'time', 'comp' )
 
              !TODO: move this assertion into 'preprocess'.
-             IF ( .NOT. ALL(input_buffer(:) % is_preprocessed .AND. .TRUE.) )  THEN
-                message = "Input buffers for group '" // TRIM(group % kind) // &
-                   "' could not be preprocessed sucessfully."
-                CALL inifor_abort('main loop', message)
+             IF ( .NOT. ALL(input_buffer(:)%is_preprocessed .AND. .TRUE.) )  THEN
+                message = "Input buffers for group '" // TRIM( group%kind ) // &
+                          "' could not be preprocessed sucessfully."
+                CALL inifor_abort( 'main loop', message )
              ENDIF
 
 !------------------------------------------------------------------------------
-!- Section 2.2: Interpolate each output variable of the group
-!------------------------------------------------------------------------------
-             DO ivar = 1, group % nv
-
-                output_var => group % out_vars( ivar )
-
-                IF ( output_var % to_be_processed .AND.                        &
-                     iter .LE. output_var % nt )  THEN
-
-                   message = "Processing '" // TRIM(output_var % name) //      &
-                             "' (" // TRIM(output_var % kind) //               &
-                             "), iteration " // TRIM(str(iter)) //" of " //    &
-                             TRIM(str(output_var % nt))
-                   CALL report('main loop', message)
-
-                   SELECT CASE( TRIM(output_var % task) )
-
-                   CASE( 'interpolate_2d' ) 
-                   
-                      SELECT CASE( TRIM(output_var % kind) )
-                       
-                      CASE( 'init soil' )
-
-                         ALLOCATE( output_arr( 0:output_var % grid % nx,       &
-                                               0:output_var % grid % ny,       &
-                                               SIZE(output_var % grid % depths) ) )
-
-                      CASE ( 'surface forcing' )
-
-                         ALLOCATE( output_arr( 0:output_var % grid % nx,       &
-                                               0:output_var % grid % ny, 1 ) )
-
-                      CASE DEFAULT
-
-                          message = "'" // TRIM(output_var % kind) // "' is not a soil variable"
-                          CALL inifor_abort("main loop", message)
-
-                      END SELECT
- CALL run_control('time', 'alloc')
-
-                      CALL interpolate_2d(input_buffer(output_var % input_id) % array(:,:,:), &
-                              output_arr(:,:,:), output_var % intermediate_grid, output_var)
- CALL run_control('time', 'comp')
-
-
-                   CASE ( 'interpolate_3d' )
-
-                      ALLOCATE( output_arr( 0:output_var % grid % nx,          &
-                                            0:output_var % grid % ny,          &
-                                            1:output_var % grid % nz ) )
-
- CALL run_control('time', 'alloc')
-                      CALL interpolate_3d(                                     &
-                         input_buffer(output_var % input_id) % array(:,:,:),   &
-                         output_arr(:,:,:),                                    &
-                         output_var % intermediate_grid,                       &
-                         output_var % grid)
- CALL run_control('time', 'comp')
-
-                   CASE ( 'average profile' )
-
-                      ALLOCATE( output_arr( 0:output_var % grid % nx,          &
-                                            0:output_var % grid % ny,          &
-                                            1:output_var % grid % nz ) )
- CALL run_control('time', 'alloc')
+!-- Section 2.2: Interpolate each output variable of the group
+!------------------------------------------------------------------------------
+             DO  ivar = 1, group%nv
+
+                output_var => group%out_vars(ivar)
+
+                IF ( output_var%to_be_processed .AND.                          &
+                     iter .LE. output_var%nt )  THEN
+
+                   message = "Processing '" // TRIM( output_var%name ) //      &
+                             "' (" // TRIM( output_var%kind ) //               &
+                             "), iteration " // TRIM( str( iter ) ) //" of " //&
+                             TRIM( str( output_var%nt ) )
+                   CALL report( 'main loop', message )
+
+                   SELECT CASE( TRIM( output_var%task ) )
+
+!--                   2D horizontal interpolation
+                      CASE( 'interpolate_2d' ) 
                       
-                      CALL interp_average_profile(                             &
-                         input_buffer(output_var % input_id) % array(:,:,:),   &
-                         output_arr(0,0,:),                                    &
-                         output_var % averaging_grid)
-
-                      IF ( TRIM(output_var % name) ==                          &
-                           'surface_forcing_surface_pressure' )  THEN
-
-                         IF ( cfg % p0_is_set )  THEN
-                            output_arr(0,0,1) = p0
-                         ELSE
-                            CALL get_surface_pressure(                         &
-                               output_arr(0,0,:), rho_centre,                  &
-                               output_var % averaging_grid)
+                         SELECT CASE( TRIM( output_var%kind ) )
+                          
+                         CASE( 'init soil' )
+   
+                            ALLOCATE( output_arr(0:output_var%grid%nx,            &
+                                                 0:output_var%grid%ny,            &
+                                                 SIZE( output_var%grid%depths )) )
+   
+                         CASE ( 'surface forcing' )
+   
+                            ALLOCATE( output_arr(0:output_var%grid%nx,            &
+                                                 0:output_var%grid%ny, 1) )
+   
+                         CASE DEFAULT
+   
+                             message = "'" // TRIM( output_var%kind ) // "' is not a soil variable"
+                             CALL inifor_abort( "main loop", message )
+   
+                         END SELECT
+                         CALL log_runtime( 'time', 'alloc' )
+   
+                         CALL interpolate_2d( input_buffer(output_var%input_id)%array(:,:,:), &
+                                 output_arr(:,:,:), output_var%intermediate_grid, output_var )
+                         CALL log_runtime( 'time', 'comp' )
+   
+   
+!--                   Interpolation in 3D, used for atmospheric initial and
+!--                   boundary conditions.
+                      CASE ( 'interpolate_3d' )
+   
+                         ALLOCATE( output_arr(0:output_var%grid % nx,           &
+                                              0:output_var%grid % ny,           &
+                                              1:output_var%grid % nz) )
+   
+                         CALL log_runtime( 'time', 'alloc' )
+                         CALL interpolate_3d(                                     &
+                            input_buffer(output_var%input_id)%array(:,:,:),       &
+                            output_arr(:,:,:),                                    &
+                            output_var%intermediate_grid,                         &
+                            output_var%grid)
+                         CALL log_runtime( 'time', 'comp' )
+   
+!--                   Compute initial avaerage profiles (if --init-mode profile
+!--                   is used) 
+                      CASE ( 'average profile' )
+   
+                         ALLOCATE( output_arr(0:output_var%grid%nx,               &
+                                              0:output_var%grid%ny,               &
+                                              1:output_var%grid%nz) )
+                         CALL log_runtime( 'time', 'alloc' )
+                         
+                         CALL interp_average_profile(                             &
+                            input_buffer(output_var%input_id)%array(:,:,:),     &
+                            output_arr(0,0,:),                                    &
+                            output_var%averaging_grid )
+   
+                         IF ( TRIM( output_var%name ) ==                          &
+                              'surface_forcing_surface_pressure' )  THEN
+   
+                            IF ( cfg%p0_is_set )  THEN
+                               output_arr(0,0,1) = p0
+                            ELSE
+                               CALL get_surface_pressure(                         &
+                                  output_arr(0,0,:), rho_centre,                  &
+                                  output_var%averaging_grid )
+                            ENDIF
+   
                          ENDIF
-
-                      ENDIF
- CALL run_control('time', 'comp')
-
-                   CASE ( 'internal profile' )
-
-                      message = "Averaging of internal profile for variable '" //&
-                         TRIM(output_var % name) // "' is not supported."
-
-                      SELECT CASE (TRIM(output_var % name))
-
-                      CASE('internal_density_centre')
-                         ALLOCATE( rho_centre( 1:cosmo_grid % nz) )
-                         internal_arr => rho_centre
-
-                      CASE('internal_density_north')
-                         ALLOCATE( rho_north( 1:cosmo_grid % nz) )
-                         internal_arr => rho_north
-
-                      CASE('internal_density_south')
-                         ALLOCATE( rho_south( 1:cosmo_grid % nz) )
-                         internal_arr => rho_south
-
-                      CASE('internal_density_east')
-                         ALLOCATE( rho_east( 1:cosmo_grid % nz) )
-                         internal_arr => rho_east
-
-                      CASE('internal_density_west')
-                         ALLOCATE( rho_west( 1:cosmo_grid % nz) )
-                         internal_arr => rho_west
-
-                      CASE('internal_pressure_north')
-                         ALLOCATE( p_north( 1:cosmo_grid % nz) )
-                         internal_arr => p_north
-
-                      CASE('internal_pressure_south')
-                         ALLOCATE( p_south( 1:cosmo_grid % nz) )
-                         internal_arr => p_south
-
-                      CASE('internal_pressure_east')
-                         ALLOCATE( p_east( 1:cosmo_grid % nz) )
-                         internal_arr => p_east
-
-                      CASE('internal_pressure_west')
-                         ALLOCATE( p_west( 1:cosmo_grid % nz) )
-                         internal_arr => p_west
-
-                      CASE DEFAULT
-                         CALL inifor_abort('main loop', message)
-
-                      END SELECT
- CALL run_control('time', 'alloc')
-
-
-                      SELECT CASE( TRIM( output_var % name ) )
-
-                      CASE( 'internal_pressure_north',                         &
-                            'internal_pressure_south',                         &
-                            'internal_pressure_east',                          &
-                            'internal_pressure_west' )
-
-                         CALL average_pressure_perturbation(                   &
-                            input_buffer(output_var % input_id) % array(:,:,:),&
-                            internal_arr(:),                                   &
-                            cosmo_grid, output_var % averaging_grid            &
-                         )
-
-                      CASE DEFAULT
-
-                         CALL average_profile(                                 &
-                            input_buffer(output_var % input_id) % array(:,:,:),&
-                            internal_arr(:),                                   &
-                            output_var % averaging_grid                        &
-                         )
+                         CALL log_runtime( 'time', 'comp' )
+   
+!--                   Compute internal profiles, required for differentiation of
+!--                   geostrophic wind
+                      CASE ( 'internal profile' )
+   
+                         message = "Averaging of internal profile for variable '" //&
+                            TRIM( output_var%name ) // "' is not supported."
+   
+                         SELECT CASE ( TRIM( output_var%name ) )
+   
+                         CASE( 'internal_density_centre' )
+                            ALLOCATE( rho_centre(1:cosmo_grid%nz) )
+                            internal_arr => rho_centre
+   
+                         CASE( 'internal_density_north' )
+                            ALLOCATE( rho_north(1:cosmo_grid%nz) )
+                            internal_arr => rho_north
+   
+                         CASE( 'internal_density_south' )
+                            ALLOCATE( rho_south(1:cosmo_grid%nz) )
+                            internal_arr => rho_south
+   
+                         CASE( 'internal_density_east' )
+                            ALLOCATE( rho_east(1:cosmo_grid%nz) )
+                            internal_arr => rho_east
+   
+                         CASE( 'internal_density_west' )
+                            ALLOCATE( rho_west(1:cosmo_grid%nz) )
+                            internal_arr => rho_west
+   
+                         CASE( 'internal_pressure_north' )
+                            ALLOCATE( p_north(1:cosmo_grid%nz) )
+                            internal_arr => p_north
+   
+                         CASE( 'internal_pressure_south' )
+                            ALLOCATE( p_south(1:cosmo_grid%nz) )
+                            internal_arr => p_south
+   
+                         CASE( 'internal_pressure_east' )
+                            ALLOCATE( p_east(1:cosmo_grid%nz) )
+                            internal_arr => p_east
+   
+                         CASE( 'internal_pressure_west' )
+                            ALLOCATE( p_west(1:cosmo_grid%nz) )
+                            internal_arr => p_west
+   
+                         CASE DEFAULT
+                            CALL inifor_abort( 'main loop', message )
+   
+                         END SELECT
+                         CALL log_runtime( 'time', 'alloc' )
+   
+   
+                         SELECT CASE( TRIM( output_var%name ) )
+   
+                         CASE( 'internal_pressure_north',                         &
+                               'internal_pressure_south',                         &
+                               'internal_pressure_east',                          &
+                               'internal_pressure_west' )
+   
+                            CALL average_pressure_perturbation(                   &
+                               input_buffer(output_var%input_id) % array(:,:,:),&
+                               internal_arr(:),                                   &
+                               cosmo_grid, output_var%averaging_grid            &
+                            )
+   
+                         CASE DEFAULT
+   
+                            CALL average_profile(                                 &
+                               input_buffer(output_var%input_id) % array(:,:,:),&
+                               internal_arr(:),                                   &
+                               output_var%averaging_grid                        &
+                            )
 
                       END SELECT
@@ -360,8 +413,8 @@
 !--                   (requires definiton of COSMO levels in netCDF output.)
                       !IF (.TRUE.)  THEN
-                      !   ALLOCATE( output_arr(1,1,1:output_var % grid % nz) )
+                      !   ALLOCATE( output_arr(1,1,1:output_var%grid % nz) )
                       !   output_arr(1,1,:) = internal_arr(:)
                       !ENDIF
- CALL run_control('time', 'comp')
+                      CALL log_runtime( 'time', 'comp' )
 
 !
@@ -372,12 +425,12 @@
 
                       IF (.NOT. ug_vg_have_been_computed )  THEN
-                         ALLOCATE( ug_palm(output_var % grid % nz) )
-                         ALLOCATE( vg_palm(output_var % grid % nz) )
-                         ALLOCATE( ug_cosmo(cosmo_grid % nz) )
-                         ALLOCATE( vg_cosmo(cosmo_grid % nz) )
-
-                         IF ( cfg % ug_defined_by_user )  THEN
-                            ug_palm = cfg % ug
-                            vg_palm = cfg % vg
+                         ALLOCATE( ug_palm(output_var%grid%nz) )
+                         ALLOCATE( vg_palm(output_var%grid%nz) )
+                         ALLOCATE( ug_cosmo(cosmo_grid%nz) )
+                         ALLOCATE( vg_cosmo(cosmo_grid%nz) )
+
+                         IF ( cfg%ug_defined_by_user )  THEN
+                            ug_palm = cfg%ug
+                            vg_palm = cfg%vg
                          ELSE
                             CALL geostrophic_winds( p_north, p_south, p_east,  &
@@ -390,8 +443,8 @@
 
                             CALL interpolate_1d( ug_cosmo, ug_palm,             &
-                                                 output_var % grid )
+                                                 output_var%grid )
 
                             CALL interpolate_1d( vg_cosmo, vg_palm,             &
-                                                 output_var % grid )
+                                                 output_var%grid )
                          ENDIF
 
